// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/MrkSkipTable.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class MrkSkipTable extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inMrkSkip = 2;
  public static final int inMrkTable = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\5\0\1\4\10\0\1\5\12\6\1\7\1\10\1\11"+
    "\1\0\1\12\2\0\1\13\1\14\2\0\1\15\2\0"+
    "\1\16\1\17\1\0\1\20\1\21\1\22\1\23\1\0"+
    "\1\24\1\0\1\25\1\26\1\27\6\0\1\30\1\0"+
    "\1\31\3\0\1\13\1\14\2\0\1\15\2\0\1\16"+
    "\1\17\1\0\1\20\1\21\1\22\1\23\1\0\1\24"+
    "\1\0\1\25\1\26\1\27\273\0\2\17\115\0\1\26"+
    "\u0182\0\1\1\u0127\0\1\20\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\4\1\1\2\2\3\2\2\114\0\1\4\6\0"+
    "\1\5\2\0\3\4\7\0\1\6\54\0\1\5\3\0"+
    "\1\6\6\0\1\7\1\0\1\10\1\11";

  private static int [] zzUnpackAction() {
    int [] result = new int[168];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\32\0\64\0\116\0\150\0\202\0\234\0\116"+
    "\0\116\0\266\0\320\0\352\0\u0104\0\u011e\0\u0138\0\u0152"+
    "\0\u016c\0\u0186\0\u01a0\0\u01ba\0\u01d4\0\u01ee\0\u0208\0\u0222"+
    "\0\u023c\0\u0256\0\u0270\0\u028a\0\u02a4\0\u02be\0\u02d8\0\u02f2"+
    "\0\u030c\0\u0326\0\u0340\0\u035a\0\u0374\0\u038e\0\u03a8\0\u03c2"+
    "\0\u03dc\0\u03f6\0\u0410\0\u042a\0\u0444\0\u045e\0\u0478\0\u0492"+
    "\0\352\0\u04ac\0\u04c6\0\u04e0\0\u04fa\0\u0514\0\u052e\0\u0548"+
    "\0\u0562\0\u057c\0\u0596\0\u05b0\0\u05ca\0\u05e4\0\u05fe\0\u0618"+
    "\0\u0632\0\u064c\0\u0666\0\u0680\0\u069a\0\u06b4\0\u06ce\0\u06e8"+
    "\0\u0702\0\u071c\0\u0736\0\u0750\0\u076a\0\u0784\0\u079e\0\u07b8"+
    "\0\u07d2\0\u07ec\0\u0806\0\u0820\0\u083a\0\u0854\0\u086e\0\u0888"+
    "\0\u08a2\0\u08bc\0\u08d6\0\u08f0\0\u090a\0\u0924\0\u093e\0\u0958"+
    "\0\u0972\0\u098c\0\u09a6\0\116\0\u09c0\0\u09da\0\u09f4\0\u0a0e"+
    "\0\u0a28\0\u0a42\0\u0a5c\0\u0a76\0\u0a90\0\u0aaa\0\u0ac4\0\u0ade"+
    "\0\u0af8\0\u0b12\0\u0b2c\0\u0b46\0\u0b60\0\u0b7a\0\u0b94\0\u0bae"+
    "\0\u0bc8\0\u0be2\0\u0bfc\0\u0c16\0\u0c30\0\u0c4a\0\u0c64\0\u0c7e"+
    "\0\u0c98\0\u0cb2\0\u0ccc\0\u0ce6\0\u0d00\0\u0d1a\0\u0d34\0\u0d4e"+
    "\0\u0d68\0\u0d82\0\u0d9c\0\u0db6\0\u0dd0\0\u0dea\0\u0e04\0\u0e1e"+
    "\0\u0e38\0\u0e52\0\u0e6c\0\u0e86\0\u0ea0\0\u0eba\0\u0ed4\0\u0eee"+
    "\0\u0f08\0\116\0\u0f22\0\u0f3c\0\u0f56\0\116\0\u0f70\0\u0f8a"+
    "\0\u0fa4\0\u0fbe\0\u0fd8\0\u0ff2\0\116\0\u100c\0\116\0\116";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[168];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\11\4\1\5\16\4\1\6\12\4\1\7\20\4\2\10"+
    "\1\11\1\12\5\10\1\13\16\10\1\14\1\10\50\0"+
    "\1\15\35\0\1\16\25\0\1\17\15\0\1\11\45\0"+
    "\1\20\20\0\1\21\14\0\1\22\16\0\1\23\47\0"+
    "\1\24\13\0\1\25\31\0\1\26\44\0\1\27\34\0"+
    "\1\30\30\0\1\31\25\0\1\32\35\0\1\33\31\0"+
    "\1\34\32\0\1\35\24\0\1\36\12\0\1\37\2\0"+
    "\1\40\5\0\1\41\26\0\1\42\23\0\1\43\2\0"+
    "\1\44\5\0\1\45\20\0\1\46\2\0\1\47\5\0"+
    "\1\50\37\0\1\51\20\0\1\52\22\0\12\37\1\41"+
    "\17\37\23\0\1\53\36\0\1\54\30\0\1\55\2\0"+
    "\12\43\1\45\17\43\23\0\1\56\36\0\1\57\1\0"+
    "\12\46\1\50\17\46\23\0\1\60\36\0\1\61\10\0"+
    "\1\62\51\0\1\63\16\0\1\64\37\0\1\65\22\0"+
    "\1\66\32\0\1\67\22\0\1\70\14\0\1\71\23\0"+
    "\1\72\44\0\1\73\15\0\1\74\44\0\1\75\30\0"+
    "\1\76\20\0\1\77\43\0\1\100\25\0\1\101\34\0"+
    "\1\102\32\0\1\103\16\0\1\104\32\0\1\105\41\0"+
    "\1\106\25\0\1\107\32\0\1\110\34\0\1\111\32\0"+
    "\1\112\24\0\1\113\35\0\1\114\21\0\1\115\36\0"+
    "\1\116\20\0\1\37\30\0\1\117\37\0\1\120\24\0"+
    "\1\43\41\0\1\121\20\0\1\122\32\0\1\46\42\0"+
    "\1\123\25\0\1\124\42\0\1\125\1\55\3\0\1\126"+
    "\2\0\1\127\1\0\1\130\22\0\1\131\7\0\1\132"+
    "\50\0\1\133\20\0\1\134\15\0\1\135\2\0\1\136"+
    "\1\0\1\137\22\0\1\140\20\0\1\141\12\0\1\126"+
    "\2\0\1\127\1\0\1\130\46\0\1\142\14\0\1\130"+
    "\22\0\1\131\1\0\1\143\1\144\1\145\1\146\4\0"+
    "\1\147\46\0\1\150\23\0\1\151\12\0\1\152\2\0"+
    "\1\153\1\0\1\154\22\0\1\155\1\0\1\135\2\0"+
    "\1\136\1\0\1\137\46\0\1\156\14\0\1\137\22\0"+
    "\1\140\11\0\1\157\37\0\1\160\26\0\1\161\16\0"+
    "\1\143\1\144\1\145\1\146\27\0\1\144\52\0\1\162"+
    "\13\0\1\163\44\0\1\164\30\0\1\165\13\0\1\152"+
    "\2\0\1\153\1\0\1\154\46\0\1\166\14\0\1\154"+
    "\22\0\1\155\11\0\1\167\34\0\1\170\22\0\1\171"+
    "\50\0\1\172\33\0\1\173\17\0\1\174\33\0\1\175"+
    "\32\0\1\176\36\0\1\177\21\0\1\200\22\0\1\201"+
    "\52\0\1\202\21\0\1\203\44\0\1\204\24\0\1\205"+
    "\33\0\1\206\12\0\1\207\46\0\1\210\36\0\1\211"+
    "\26\0\1\212\21\0\1\213\37\0\1\214\14\0\1\215"+
    "\33\0\1\216\30\0\1\126\45\0\1\217\31\0\1\220"+
    "\36\0\1\221\11\0\1\222\44\0\1\223\14\0\1\224"+
    "\32\0\1\135\45\0\1\225\12\0\1\226\34\0\1\143"+
    "\33\0\1\143\30\0\1\227\25\0\1\230\34\0\1\152"+
    "\45\0\1\231\17\0\1\232\35\0\1\233\20\0\1\234"+
    "\42\0\1\235\25\0\1\236\26\0\1\237\40\0\1\240"+
    "\22\0\1\241\46\0\1\242\14\0\1\243\46\0\1\244"+
    "\17\0\1\245\43\0\1\246\17\0\1\247\31\0\1\250"+
    "\17\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[4134];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\3\1\2\11\3\1\114\0\1\1\6\0"+
    "\1\1\2\0\1\1\1\11\1\1\7\0\1\1\54\0"+
    "\1\11\3\0\1\11\6\0\1\11\1\0\2\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[168];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	MrkSkipTable() { }
	
	private int columns = 1;
	
	private int column = 0;
	
	private boolean openTr = false;
	
	private StringBuilder buffer = new StringBuilder();
	
	
	private void readColumns() {
	
		String firstNum = Util.readFirstNumber(yytext());
		
		if(firstNum == null || firstNum.equals(""))  {
			
			columns = 1;
			return;
		}
		
		try {
			
			columns = Integer.valueOf(firstNum);
			
		} catch (NumberFormatException e) {

			columns = 1;
		}
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public MrkSkipTable(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inMrkSkip: {
              if(getMarkerDocument().isDebug()) System.out.println("Annotazioni [MRK:SKIP] nel testo in input non bilanciate");
	
		getMarkerDocument().addError("Annotazioni [MRK:SKIP] nel testo in input non bilanciate");
		
		output.append("</mrk:skip>");
		
		return YYEOF;
            }  // fall though
            case 169: break;
            case inMrkTable: {
              if(getMarkerDocument().isDebug()) System.out.println("Annotazioni [MRK:TABLE] nel testo in input non bilanciate");
	
		getMarkerDocument().addError("Annotazioni [MRK:TABLE] nel testo in input non bilanciate");
		
		output.append("</h:table>");
		
		return YYEOF;
            }  // fall though
            case 170: break;
            default:
        return YYEOF;
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 10: break;
          case 2:
            { buffer.append(yytext());
            }
          // fall through
          case 11: break;
          case 3:
            { if(buffer.length() == 0) {
			
			//c'è una riga vuota, aggiungi una cella vuota
				
			output.append("<h:td></h:td>");
		}
	
		if( !openTr) {
			
			output.append("\n<h:tr>");
			openTr = true;
		}
		
		output.append("<h:td>" + buffer.toString() + "</h:td>");
		
		buffer = new StringBuilder();
		
		column++;
		
		if(column == columns) {
		
			output.append("</h:tr>");
			
			openTr = false;
			
			column = 0;
		}
            }
          // fall through
          case 12: break;
          case 4:
            { readColumns();
	
	column = 0;
	
	openTr = true;
	
	output.append("<h:table>\n<h:tr>");
	
	buffer = new StringBuilder();
	
	yybegin(inMrkTable);
            }
          // fall through
          case 13: break;
          case 5:
            { if(getMarkerDocument().isDebug()) System.out.println("Annotazioni [MRK:TABLE] nel testo in input non bilanciate");
	
		getMarkerDocument().addError("Annotazioni [MRK:TABLE] nel testo in input non bilanciate");
            }
          // fall through
          case 14: break;
          case 6:
            { if(openTr) {
		
			output.append("</h:tr>");
			openTr = false;
			column = 0;
		}
		
		output.append("</h:table>"); yybegin(0);
            }
          // fall through
          case 15: break;
          case 7:
            { output.append("<mrk:skip>"); yybegin(inMrkSkip);
            }
          // fall through
          case 16: break;
          case 8:
            { if(getMarkerDocument().isDebug()) System.out.println("Annotazioni [MRK:SKIP] nel testo in input non bilanciate");
	
		getMarkerDocument().addError("Annotazioni [MRK:SKIP] nel testo in input non bilanciate");
            }
          // fall through
          case 17: break;
          case 9:
            { output.append("</mrk:skip>"); yybegin(0);
            }
          // fall through
          case 18: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java MrkSkipTable [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        MrkSkipTable scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new MrkSkipTable(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
